@Echo off
::                           Compressor Test Ver. 1.1
::
::  Pierfranco Ferronato 2:333/705@Fidonet
::  Calcolo delle prestazioni dei compressori
::  Tempo / Velocita' Compressione e Decompressione
::    Liberi di modificarlo a piacere ma con il tacito accordo di farmi avere
::    la vostra versione :)
loadbtm on
setlocal
set maxcompr=6
set maxbar=55

set compr1=Zip
set compr2=Arj
set compr3=Uc2
set compr4=Rar
set compr5=Lha
set compr6=Zoo

if "%1"=="/?" goto help

set what=*.*
if %@filesize[%1,b] gt 0 set what=%1
if %@filesize[%2,b] gt 0 set what=%2

unset redir>&nul
if %1=="/f" .or. %2=="/f" set redir=>>results.txt

:: ---- nomi di file e dir temporanei
set ndir=$$$___.$$$
set nfil=___$$$.___

:: ---- comandi di compressione
set comprcomm1=pkzip -+ -ex
set comprcomm2=arj a
set comprcomm3=uc a -f
set comprcomm4=rar a
set comprcomm5=lha a /m
set comprcomm6=zoo -add

:: ---- comandi di decompressione
set deccomm1=pkunzip -+
set deccomm2=arj e
set deccomm3=uc e -f
set deccomm4=rar e
set deccomm5=lha e
set deccomm6=zoo -extract

md %ndir>nul
cls
do count=1 to %maxcompr
        set time_start=%_time
        %[comprcomm%count] %nfil %what
        set TTime%count=%@eval[%@time[%_time]-%@time[%time_start]]
        set size%count=%@filesize[%nfil,k]
        copy %nfil %ndir
        del %nfil>nul
        cd %ndir
        set time_start=%_time
        %[deccomm%count] %nfil
        set ttimed%count=%@eval[%@time[%_time]-%@time[%time_start]]
        del./y/z>nul
        cd..
enddo
rd %ndir>nul

cls
if %@len[%redir] gt 0 Echo Be patient ...
::  TIME COMPRESSION 
:: ---- trova il max tra 5 numeri per definire il massimo della barra
set maxtime=%ttime1
do count=2 to %maxcompr
        iff %[ttime%count] ge %maxtime then
                set maxtime=%[ttime%count]
        endiff
enddo

:: ---- calcolo dalla lunghezza delle barre
do count=1 to %maxcompr
        set timebar%count=%@eval[%[ttime%count]*%maxbar/%maxtime]
enddo
gosub intro
Echo - Time Compression Graph  %maxtime Sec.%redir
:: ---- disegno delle barre
do count=1 to %maxcompr
        set line=%[compr%count]
        set tmp=%[timebar%count]
        if %tmp le 0 goto/i skip11
        gosub color1
        do %tmp
          set line=%line
        enddo
:skip11
        set tmp=%@eval[%maxbar-%[timebar%count]]
        if %tmp le 0 goto/i skip12
        gosub color2
        do %tmp
          set line=%line
        enddo
:skip12
        gosub color3
        set line=%line%[ttime%count]Sec (%@int[%@eval[%[size%count]/%[ttime%count]]]Kb/Sec)
        echo %line %redir
enddo
::  TIME DECOMPRESSION 
:: ---- calcolo dalla lunghezza delle barre
do count=1 to %maxcompr
        set timedbar%count=%@eval[%[ttimed%count]*%maxbar/%maxtime]
enddo
Echo - Time Decompression Graph  %maxtime Sec.%redir
:: ---- disegno delle barre
do count=1 to %maxcompr
        set line=%[compr%count]
        set rest=%[timedbar%count]
        if %rest le 0 goto/i skip21
        gosub color1
        do %rest
          set line=%line
        enddo
:skip21
        set rest=%@eval[%maxbar-%[timedbar%count]]
        if %rest le 0 goto/i skip22
        gosub color2
        do %rest
          set line=%line
        enddo
:skip22
        gosub color3
        set line=%line%[ttimed%count]Sec (%@int[%@eval[%[size%count]/%[ttimed%count]]]Kb/Sec)
        echo %line %redir
enddo
::  SIZE 
:: ---- calcolo della lunghezza della barre
set maxsize=%@filesize[*.*,k]
do count=1 to %maxcompr
        set sizebar%count=%@eval[%[size%count]*%maxbar/%maxsize]
enddo
Echo  Size Bar Graph  %maxsize Kbyte%redir
do count=1 to %maxcompr
        set line=%[compr%count]
	set rest=%[sizebar%count]
        if %rest le 0 goto/i skip31
        gosub color1
	do %rest
          set line=%line
        enddo
:skip31
        set rest=%@eval[%maxbar-%[sizebar%count]]
        if %rest le 0 goto/i skip32
        gosub color2
        do %rest
          set line=%line
        enddo
:skip32
        gosub color3
        set line=%line%[size%count]Kb (%@int[%@eval[100-%[size%count]/%maxsize*100]] %@char[37])
        echo %line %redir
enddo
goto stop
:: 
:: routines

:color1
color bright while on blue
return

:color2
color white on blue
return

:color3
color white on black
return

:intro
Echo Compressors evaluation test V. 1.1 - By Pieffe '65%redir
Echo Testing %what %redir
return

:help
gosub intro
text
Syntax: TESTK11 [<MASK>] [/f] | [/f] | [<MASK>] | [/f] [<MASK>] | [/?]
        /?      - this
        /f      - redirect output to the file "result.txt"
        <MASK>  - files to test (default value is "*.*" no subdir recursion)
                  any dos wildcard accepted or specific file name

Case sensitive - Have fun - Test all the day long ... :)
endtext

:stop
pause
cls
Echo If you modify it, please send me your new version. I'll be glad to see it.
Echo Distributed under the HappyWare concept - If you like it, remember to smile
Echo            Ŀ
Echo              Pierfranco Ferronato 2:333/705@FidoNet      
Echo            
endlocal
exit
